#include <TOS.H>

#ifndef BOOLE
 #define BOOLE
 typedef enum               /* Boolean Variables */
 {
    FALSE,
    TRUE
 }
 boolean;
#endif

typedef struct
{
   long cookie_id;            /* Cookie ID   */
   long cookie_value;         /* Cookie Value */
} COOKIE;

boolean getcookie(long cookie, long *p_value)
{
   /*  Read Cookie                                */
   /*  -----------                                */
   /*  cookie          Magic                      */
   /*  p_value         Value                      */
   /*  max_cookies     Number of possible cookies */

   register long usp;
   COOKIE *cookiejar;

   usp = Super(0L);
   cookiejar = (COOKIE *) *((long *) 0x5a0L);
   Super( (void *) usp);

   if (cookiejar == 0L)
      return FALSE;
   else
   {
      do                                     /* Cookie search loop  */
      {
         if (cookiejar->cookie_id == cookie)
         {
            if (p_value) /* if not NULL pointer */
               *p_value = cookiejar->cookie_value;
            return TRUE;
         }
      }
      while (cookiejar++->cookie_id != 0);
   }
   return FALSE;
}
/* ----------------- */
